<?php
 class elFinderVolumeBox extends elFinderVolumeDriver {
 protected $driverId = 'bd';
 const API_URL = 'https://api.box.com/2.0';
 const AUTH_URL = 'https://www.box.com/api/oauth2/authorize';
 const TOKEN_URL = 'https://www.box.com/api/oauth2/token';
 const UPLOAD_URL = 'https://upload.box.com/api/2.0';
 const FETCHFIELDS = 'type,id,name,created_at,modified_at,description,size,parent,permissions,file_version,shared_link';
 protected $token = null;
 protected $tmp = '';
 public $netMountKey = '';
 private $tmbPrefix = '';
 protected $HasdirsCache = array();
 public function __construct() {
 $opts = array( 'client_id' => '', 'client_secret' => '', 'accessToken' => '', 'root' => 'Box.com', 'path' => '/', 'separator' => '/', 'tmbPath' => '', 'tmbURL' => '', 'tmpPath' => '', 'acceptedName' => '#^[^/\\?*:|"<>]*[^./\\?*:|"<>]$#', 'rootCssClass' => 'elfinder-navbar-root-box', );
 $this->options = array_merge($this->options, $opts);
 $this->options['mimeDetect'] = 'internal';
 }
 protected function _bd_splitPath($path) {
 $path = trim($path, '/');
 $pid = '';
 if ($path === '') {
 $id = '0';
 $parent = '';
 }
 else {
 $paths = explode('/', trim($path, '/'));
 $id = array_pop($paths);
 if ($paths) {
 $parent = '/' . implode('/', $paths);
 $pid = array_pop($paths);
 }
 else {
 $pid = '0';
 $parent = '/';
 }
 }
 return array($pid, $id, $parent);
 }
 protected function _bd_obtainAccessToken($client_id, $client_secret, $code) {
 if (null === $client_id) {
 return $this->setError('The client ID must be set to call obtainAccessToken()');
 }
 if (null === $client_secret) {
 return $this->setError('The client Secret must be set to call obtainAccessToken()');
 }
 if (null === $code) {
 return $this->setError('Authorization code must be set to call obtainAccessToken()');
 }
 $url = self::TOKEN_URL;
 $curl = curl_init();
 $fields = http_build_query( array( 'client_id' => $client_id, 'client_secret' => $client_secret, 'code' => $code, 'grant_type' => 'authorization_code', ) );
 curl_setopt_array($curl, array( CURLOPT_RETURNTRANSFER => true, CURLOPT_POST => true, CURLOPT_POSTFIELDS => $fields, CURLOPT_URL => $url, ));
 $decoded = $this->_bd_curlExec($curl, true, array('Content-Length: ' . strlen($fields)));
 return (object)array( 'expires' => time() + $decoded->expires_in - 30, 'data' => $decoded, );
 }
 protected function _bd_refreshToken() {
 if (!property_exists($this->token, 'expires') || $this->token->expires < time()) {
 if (!$token = $this->session->get('BoxTokens')) {
 $token = $this->token;
 }
 if (empty($token->data->refresh_token)) {
 $this->session->remove('BoxTokens');
 throw new \Exception(elFinder::ERROR_REAUTH_REQUIRE);
 }
 if (!$this->options['client_id']) {
 $this->options['client_id'] = ELFINDER_BOX_CLIENTID;
 }
 if (!$this->options['client_secret']) {
 $this->options['client_secret'] = ELFINDER_BOX_CLIENTSECRET;
 }
 $url = self::TOKEN_URL;
 $curl = curl_init();
 curl_setopt_array($curl, array( CURLOPT_RETURNTRANSFER => true, CURLOPT_POST => true, CURLOPT_POSTFIELDS => 'client_id=' . urlencode($this->options['client_id']) . '&client_secret=' . urlencode($this->options['client_secret']) . '&grant_type=refresh_token' . '&refresh_token=' . urlencode($token->data->refresh_token), CURLOPT_URL => $url, ));
 $decoded = $this->_bd_curlExec($curl);
 if (empty($decoded->access_token)) {
 throw new \Exception(elFinder::ERROR_REAUTH_REQUIRE);
 }
 $token = (object)array( 'expires' => time() + $decoded->expires_in - 30, 'data' => $decoded, );
 $this->session->set('BoxTokens', $token);
 $this->options['accessToken'] = json_encode($token);
 $this->token = $token;
 if (!empty($this->options['netkey'])) {
 elFinder::$instance->updateNetVolumeOption($this->options['netkey'], 'accessToken', $this->options['accessToken']);
 }
 }
 return true;
 }
 protected function _bd_prepareCurl($options = array()) {
 $curl = curl_init();
 $defaultOptions = array( CURLOPT_RETURNTRANSFER => true, );
 curl_setopt_array($curl, $options + $defaultOptions);
 return $curl;
 }
 protected function _bd_fetch($url, $contents = false) {
 $curl = curl_init($url);
 curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
 if ($contents) {
 return $this->_bd_curlExec($curl, false);
 }
 else {
 $result = $this->_bd_curlExec($curl);
 if (isset($result->entries)) {
 $res = $result->entries;
 $cnt = count($res);
 $total = $result->total_count;
 $offset = $result->offset;
 $single = ($result->limit == 1) ? true : false;
 if (!$single && $total > ($offset + $cnt)) {
 $offset = $offset + $cnt;
 if (strpos($url, 'offset=') === false) {
 $url .= '&offset=' . $offset;
 }
 else {
 $url = preg_replace('/^(.+?offset=)\d+(.*)$/', '${1}' . $offset . '$2', $url);
 }
 $more = $this->_bd_fetch($url);
 if (is_array($more)) {
 $res = array_merge($res, $more);
 }
 }
 return $res;
 }
 else {
 if (isset($result->type) && $result->type === 'error') {
 return false;
 }
 else {
 return $result;
 }
 }
 }
 }
 protected function _bd_curlExec($curl, $decodeOrParent = true, $headers = array()) {
 $headers = array_merge(array( 'Authorization: Bearer ' . $this->token->data->access_token, ), $headers);
 $result = elFinder::curlExec($curl, array(), $headers);
 if (!$decodeOrParent) {
 return $result;
 }
 $decoded = json_decode($result);
 if (!empty($decoded->error_code)) {
 $errmsg = $decoded->error_code;
 if (!empty($decoded->message)) {
 $errmsg .= ': ' . $decoded->message;
 }
 throw new \Exception($errmsg);
 }
 if ($decodeOrParent && $decodeOrParent !== true) {
 $raws = null;
 if (isset($decoded->entries)) {
 $raws = $decoded->entries;
 }
 elseif (isset($decoded->id)) {
 $raws = array($decoded);
 }
 if ($raws) {
 foreach ($raws as $raw) {
 if (isset($raw->id)) {
 $stat = $this->_bd_parseRaw($raw);
 $itemPath = $this->_joinPath($decodeOrParent, $raw->id);
 $this->updateCache($itemPath, $stat);
 }
 }
 }
 }
 return $decoded;
 }
 protected function _bd_query($itemId, $fetch_self = false, $recursive = false) {
 $result = [];
 if (null === $itemId) {
 $itemId = '0';
 }
 if ($fetch_self) {
 $path = '/folders/' . $itemId . '?fields=' . self::FETCHFIELDS;
 }
 else {
 $path = '/folders/' . $itemId . '/items?limit=1000&fields=' . self::FETCHFIELDS;
 }
 $url = self::API_URL . $path;
 if ($recursive) {
 foreach ($this->_bd_fetch($url) as $file) {
 if ($file->type == 'folder') {
 $result[] = $file;
 $result = array_merge($result, $this->_bd_query($file->id, $fetch_self = false, $recursive = true));
 }
 elseif ($file->type == 'file') {
 $result[] = $file;
 }
 }
 }
 else {
 $result = $this->_bd_fetch($url);
 if ($fetch_self && !$result) {
 $path = '/files/' . $itemId . '?fields=' . self::FETCHFIELDS;
 $url = self::API_URL . $path;
 $result = $this->_bd_fetch($url);
 }
 }
 return $result;
 }
 protected function _bd_getRawItem($path) {
 if ($path == '/') {
 return $this->_bd_query('0', $fetch_self = true);
 }
 list(, $itemId) = $this->_bd_splitPath($path);
 try {
 return $this->_bd_query($itemId, $fetch_self = true);
 }
 catch (Exception $e) {
 $empty = new stdClass;
 return $empty;
 }
 }
 protected function _bd_parseRaw($raw) {
 $stat = array();
 $stat['rev'] = isset($raw->id) ? $raw->id : 'root';
 $stat['name'] = $raw->name;
 if (!empty($raw->modified_at)) {
 $stat['ts'] = strtotime($raw->modified_at);
 }
 if ($raw->type === 'folder') {
 $stat['mime'] = 'directory';
 $stat['size'] = 0;
 $stat['dirs'] = -1;
 }
 else {
 $stat['size'] = (int)$raw->size;
 if (!empty($raw->shared_link->url) && $raw->shared_link->access == 'open') {
 if ($url = $this->getSharedWebContentLink($raw)) {
 $stat['url'] = $url;
 }
 }
 elseif (!$this->disabledGetUrl) {
 $stat['url'] = '1';
 }
 }
 return $stat;
 }
 protected function _bd_getThumbnail($path) {
 list(, $itemId) = $this->_bd_splitPath($path);
 try {
 $url = self::API_URL . '/files/' . $itemId . '/thumbnail.png?min_height=' . $this->tmbSize . '&min_width=' . $this->tmbSize;
 $contents = $this->_bd_fetch($url, true);
 return $contents;
 }
 catch (Exception $e) {
 return false;
 }
 }
 protected function _bd_unlink($path, $type = null) {
 try {
 list(, $itemId) = $this->_bd_splitPath($path);
 if ($type == 'folders') {
 $url = self::API_URL . '/' . $type . '/' . $itemId . '?recursive=true';
 }
 else {
 $url = self::API_URL . '/' . $type . '/' . $itemId;
 }
 $curl = $this->_bd_prepareCurl(array( CURLOPT_URL => $url, CURLOPT_CUSTOMREQUEST => 'DELETE', ));
 $this->_bd_curlExec($curl);
 }
 catch (Exception $e) {
 return $this->setError('Box error: ' . $e->getMessage());
 }
 return true;
 }
 public function netmountPrepare($options) {
 if (empty($options['client_id']) && defined('ELFINDER_BOX_CLIENTID')) {
 $options['client_id'] = ELFINDER_BOX_CLIENTID;
 }
 if (empty($options['client_secret']) && defined('ELFINDER_BOX_CLIENTSECRET')) {
 $options['client_secret'] = ELFINDER_BOX_CLIENTSECRET;
 }
 if (isset($options['pass']) && $options['pass'] === 'reauth') {
 $options['user'] = 'init';
 $options['pass'] = '';
 $this->session->remove('BoxTokens');
 }
 if (isset($options['id'])) {
 $this->session->set('nodeId', $options['id']);
 }
 elseif ($_id = $this->session->get('nodeId')) {
 $options['id'] = $_id;
 $this->session->set('nodeId', $_id);
 }
 try {
 if (empty($options['client_id']) || empty($options['client_secret'])) {
 return array('exit' => true, 'body' => '{msg:errNetMountNoDriver}');
 }
 if (isset($_GET['code'])) {
 try {
 $this->session->set('BoxTokens', $this->_bd_obtainAccessToken($options['client_id'], $options['client_secret'], $_GET['code']));
 $out = array( 'node' => $options['id'], 'json' => '{"protocol": "box", "mode": "done", "reset": 1}', 'bind' => 'netmount', );
 return array('exit' => 'callback', 'out' => $out);
 }
 catch (Exception $e) {
 $out = array( 'node' => $options['id'], 'json' => json_encode(array('error' => $e->getMessage())), );
 return array('exit' => 'callback', 'out' => $out);
 }
 }
 elseif (!empty($_GET['error'])) {
 $out = array( 'node' => $options['id'], 'json' => json_encode(array('error' => elFinder::ERROR_ACCESS_DENIED)), );
 return array('exit' => 'callback', 'out' => $out);
 }
 if ($options['user'] === 'init') {
 $this->token = $this->session->get('BoxTokens');
 if ($this->token) {
 try {
 $this->_bd_refreshToken();
 }
 catch (Exception $e) {
 $this->setError($e->getMessage());
 $this->token = null;
 $this->session->remove('BoxTokens');
 }
 }
 if (empty($this->token)) {
 $result = false;
 }
 else {
 $path = $options['path'];
 if ($path === '/' || $path === 'root') {
 $path = '0';
 }
 $result = $this->_bd_query($path, $fetch_self = false, $recursive = false);
 }
 if ($result === false) {
 $cdata = '';
 $innerKeys = array('cmd', 'host', 'options', 'pass', 'protocol', 'user');
 $this->ARGS = $_SERVER['REQUEST_METHOD'] === 'POST' ? $_POST : $_GET;
 foreach ($this->ARGS as $k => $v) {
 if (!in_array($k, $innerKeys)) {
 $cdata .= '&' . $k . '=' . rawurlencode($v);
 }
 }
 if (empty($options['url'])) {
 $options['url'] = elFinder::getConnectorUrl();
 }
 $callback = $options['url'] . '?cmd=netmount&protocol=box&host=box.com&user=init&pass=return&node=' . $options['id'] . $cdata;
 try {
 $this->session->set('BoxTokens', (object)array('token' => null));
 $url = self::AUTH_URL . '?' . http_build_query(array('response_type' => 'code', 'client_id' => $options['client_id'], 'redirect_uri' => elFinder::getConnectorUrl() . '?cmd=netmount&protocol=box&host=1'));
 $url .= '&oauth_callback=' . rawurlencode($callback);
 }
 catch (Exception $e) {
 return array('exit' => true, 'body' => '{msg:errAccess}');
 }
 $html = '<input id="elf-volumedriver-box-host-btn" class="ui-button ui-widget ui-state-default ui-corner-all ui-button-text-only" value="{msg:btnApprove}" type="button" onclick="window.open(\'' . $url . '\')">';
 $html .= '<script>
							$("#' . $options['id'] . '").elfinder("instance").trigger("netmount", {protocol: "box", mode: "makebtn"});
						</script>';
 return array('exit' => true, 'body' => $html);
 }
 else {
 $folders = [];
 if ($result) {
 foreach ($result as $res) {
 if ($res->type == 'folder') {
 $folders[$res->id . ' '] = $res->name;
 }
 }
 natcasesort($folders);
 }
 if ($options['pass'] === 'folders') {
 return ['exit' => true, 'folders' => $folders];
 }
 $folders = ['root' => 'My Box'] + $folders;
 $folders = json_encode($folders);
 $expires = empty($this->token->data->refresh_token) ? (int)$this->token->expires : 0;
 $json = '{"protocol": "box", "mode": "done", "folders": ' . $folders . ', "expires": ' . $expires . '}';
 $html = 'Box.com';
 $html .= '<script>
							$("#' . $options['id'] . '").elfinder("instance").trigger("netmount", ' . $json . ');
							</script>';
 return array('exit' => true, 'body' => $html);
 }
 }
 }
 catch (Exception $e) {
 return array('exit' => true, 'body' => '{msg:errNetMountNoDriver}');
 }
 if ($_aToken = $this->session->get('BoxTokens')) {
 $options['accessToken'] = json_encode($_aToken);
 }
 else {
 $this->setError(elFinder::ERROR_NETMOUNT, $options['host'], implode(' ', $this->error()));
 return array('exit' => true, 'error' => $this->error());
 }
 $this->session->remove('nodeId');
 unset($options['user'], $options['pass'], $options['id']);
 return $options;
 }
 public function netunmount($netVolumes, $key) {
 if ($tmbs = glob(rtrim($this->options['tmbPath'], '\\/') . DIRECTORY_SEPARATOR . $this->tmbPrefix . '*.png')) {
 foreach ($tmbs as $file) {
 unlink($file);
 }
 }
 return true;
 }
 public function debug() {
 $res = parent::debug();
 if (!empty($this->options['accessToken'])) {
 $res['accessToken'] = $this->options['accessToken'];
 }
 return $res;
 }
 protected function init() {
 if (!$this->options['accessToken']) {
 return $this->setError('Required option `accessToken` is undefined.');
 }
 try {
 $this->token = json_decode($this->options['accessToken']);
 $this->_bd_refreshToken();
 }
 catch (Exception $e) {
 $this->token = null;
 $this->session->remove('BoxTokens');
 return $this->setError($e->getMessage());
 }
 if (empty($options['netkey'])) {
 $_tokenKey = isset($this->token->data->refresh_token) ? $this->token->data->refresh_token : $this->token->data->access_token;
 $this->netMountKey = md5(implode('-', array('box', $this->options['path'], $_tokenKey)));
 }
 else {
 $this->netMountKey = $options['netkey'];
 }
 if ($this->options['path'] == 'root') {
 $this->options['path'] = '/';
 }
 $this->root = $this->options['path'] = $this->_normpath($this->options['path']);
 $this->options['root'] == '' ? $this->options['root'] = 'Box.com' : $this->options['root'];
 if (empty($this->options['alias'])) {
 list(, $itemId) = $this->_bd_splitPath($this->options['path']);
 $this->options['alias'] = ($this->options['path'] === '/') ? $this->options['root'] : $this->_bd_query($itemId, $fetch_self = true)->name . '@Box.com';
 }
 $this->rootName = $this->options['alias'];
 $this->tmbPrefix = 'box' . base_convert($this->netMountKey, 10, 32);
 if (!empty($this->options['tmpPath'])) {
 if ((is_dir($this->options['tmpPath']) || mkdir($this->options['tmpPath'])) && is_writable($this->options['tmpPath'])) {
 $this->tmp = $this->options['tmpPath'];
 }
 }
 if (!$this->tmp && ($tmp = elFinder::getStaticVar('commonTempPath'))) {
 $this->tmp = $tmp;
 }
 $this->options['syncChkAsTs'] = false;
 $this->options['lsPlSleep'] = max(10, $this->options['lsPlSleep']);
 $this->options['useRemoteArchive'] = true;
 return true;
 }
 protected function configure() {
 parent::configure();
 if (!$this->tmp && $this->tmbPathWritable) {
 $this->tmp = $this->tmbPath;
 }
 }
 public function umount() {
 }
 protected function isNameExists($path) {
 list(, $name, $parent) = $this->_bd_splitPath($path);
 $phash = $this->encode($parent);
 $searchExDirReg = $this->options['searchExDirReg'];
 $this->options['searchExDirReg'] = '/.*/';
 $search = $this->search($name, array(), $phash);
 $this->options['searchExDirReg'] = $searchExDirReg;
 if ($search) {
 return $search[0];
 }
 return false;
 }
 protected function cacheDir($path) {
 $this->dirsCache[$path] = array();
 $hasDir = false;
 if ($path == '/') {
 $items = $this->_bd_query('0', $fetch_self = true);
 $itemId = $items->id;
 }
 else {
 list(, $itemId) = $this->_bd_splitPath($path);
 }
 $res = $this->_bd_query($itemId);
 if ($res) {
 foreach ($res as $raw) {
 if ($stat = $this->_bd_parseRaw($raw)) {
 $itemPath = $this->_joinPath($path, $raw->id);
 $stat = $this->updateCache($itemPath, $stat);
 if (empty($stat['hidden'])) {
 if (!$hasDir && $stat['mime'] === 'directory') {
 $hasDir = true;
 }
 $this->dirsCache[$path][] = $itemPath;
 }
 }
 }
 }
 if (isset($this->sessionCache['subdirs'])) {
 $this->sessionCache['subdirs'][$path] = $hasDir;
 }
 return $this->dirsCache[$path];
 }
 protected function copy($src, $dst, $name) {
 if ($res = $this->_copy($src, $dst, $name)) {
 $this->added[] = $this->stat($res);
 return $res;
 }
 else {
 return $this->setError(elFinder::ERROR_COPY, $this->_path($src));
 }
 }
 protected function remove($path, $force = false) {
 $stat = $this->stat($path);
 $stat['realpath'] = $path;
 $this->rmTmb($stat);
 $this->clearcache();
 if (empty($stat)) {
 return $this->setError(elFinder::ERROR_RM, $this->_path($path), elFinder::ERROR_FILE_NOT_FOUND);
 }
 if (!$force && !empty($stat['locked'])) {
 return $this->setError(elFinder::ERROR_LOCKED, $this->_path($path));
 }
 if ($stat['mime'] == 'directory') {
 if (!$this->_rmdir($path)) {
 return $this->setError(elFinder::ERROR_RM, $this->_path($path));
 }
 }
 else {
 if (!$this->_unlink($path)) {
 return $this->setError(elFinder::ERROR_RM, $this->_path($path));
 }
 }
 $this->removed[] = $stat;
 return true;
 }
 protected function createTmb($path, $stat) {
 if (!$stat || !$this->canCreateTmb($path, $stat)) {
 return false;
 }
 $name = $this->tmbname($stat);
 $tmb = $this->tmbPath . DIRECTORY_SEPARATOR . $name;
 if (!$data = $this->_bd_getThumbnail($path)) {
 if (!$data = $this->_getContents($path)) {
 return false;
 }
 }
 if (!file_put_contents($tmb, $data)) {
 return false;
 }
 $tmbSize = $this->tmbSize;
 if (($s = getimagesize($tmb)) == false) {
 return false;
 }
 $result = true;
 if ($s[0] <= $tmbSize && $s[1] <= $tmbSize) {
 $result = $this->imgSquareFit($tmb, $tmbSize, $tmbSize, 'center', 'middle', $this->options['tmbBgColor'], 'png');
 }
 else {
 if ($this->options['tmbCrop']) {
 if (!(($s[0] > $tmbSize && $s[1] <= $tmbSize) || ($s[0] <= $tmbSize && $s[1] > $tmbSize)) || ($s[0] > $tmbSize && $s[1] > $tmbSize)) {
 $result = $this->imgResize($tmb, $tmbSize, $tmbSize, true, false, 'png');
 }
 if ($result && ($s = getimagesize($tmb)) != false) {
 $x = $s[0] > $tmbSize ? intval(($s[0] - $tmbSize) / 2) : 0;
 $y = $s[1] > $tmbSize ? intval(($s[1] - $tmbSize) / 2) : 0;
 $result = $this->imgCrop($tmb, $tmbSize, $tmbSize, $x, $y, 'png');
 }
 }
 else {
 $result = $this->imgResize($tmb, $tmbSize, $tmbSize, true, true, 'png');
 }
 if ($result) {
 $result = $this->imgSquareFit($tmb, $tmbSize, $tmbSize, 'center', 'middle', $this->options['tmbBgColor'], 'png');
 }
 }
 if (!$result) {
 unlink($tmb);
 return false;
 }
 return $name;
 }
 protected function tmbname($stat) {
 return $this->tmbPrefix . $stat['rev'] . $stat['ts'] . '.png';
 }
 protected function getSharedWebContentLink($raw) {
 $fExtension = pathinfo($raw->name, PATHINFO_EXTENSION);
 list($fType) = explode('/', self::mimetypeInternalDetect($raw->name));
 if ($raw->shared_link->url && ($fType == 'image' || $fType == 'video' || $fType == 'audio')) {
 if ($fExtension == 'jpg' && $fType == 'image') {
 $url = 'https://app.box.com/representation/file_version_' . $raw->file_version->id . '/image_2048_' . $fExtension . '/1.' . $fExtension . '?shared_name=' . basename($raw->shared_link->url);
 return $url;
 }
 elseif ($fExtension !== 'jpg' && $fType == 'image') {
 $url = 'https://app.box.com/representation/file_version_' . $raw->file_version->id . '/image_2048/1.' . $fExtension . '?shared_name=' . basename($raw->shared_link->url);
 return $url;
 }
 elseif ($fType == 'video') {
 $url = 'https://app.box.com/representation/file_version_' . $raw->file_version->id . '/video_480.' . $fExtension . '?shared_name=' . basename($raw->shared_link->url);
 return $url;
 }
 elseif ($fType == 'audio') {
 $url = 'https://app.box.com/index.php?rm=preview_stream&amp&file_version_' . $raw->file_version->id . '/audio/mpeg:' . $raw->name . '&shared_name=' . basename($raw->shared_link->url);
 return $url;
 }
 }
 elseif ($raw->shared_link->download_url) {
 return $raw->shared_link->download_url;
 }
 return false;
 }
 public function getContentUrl($hash, $options = array()) {
 if (!empty($options['onetime']) && $this->options['onetimeUrl']) {
 return parent::getContentUrl($hash, $options);
 }
 if (!empty($options['temporary'])) {
 $url = parent::getContentUrl($hash, $options);
 if ($url) {
 return $url;
 }
 }
 if (($file = $this->file($hash)) == false || !$file['url'] || $file['url'] == 1) {
 $path = $this->decode($hash);
 list(, $itemId) = $this->_bd_splitPath($path);
 $params['shared_link']['access'] = 'open';
 $url = self::API_URL . '/files/' . $itemId;
 $curl = $this->_bd_prepareCurl(array( CURLOPT_URL => $url, CURLOPT_CUSTOMREQUEST => 'PUT', CURLOPT_POSTFIELDS => json_encode($params), ));
 $res = $this->_bd_curlExec($curl, true, array( 'Content-Type: application/json', ));
 if ($url = $this->getSharedWebContentLink($res)) {
 return $url;
 }
 }
 return '';
 }
 protected function _dirname($path) {
 list(, , $dirname) = $this->_bd_splitPath($path);
 return $dirname;
 }
 protected function _basename($path) {
 list(, $basename) = $this->_bd_splitPath($path);
 return $basename;
 }
 protected function _joinPath($dir, $name) {
 if (strval($dir) === '0') {
 $dir = '';
 }
 return $this->_normpath($dir . '/' . $name);
 }
 protected function _normpath($path) {
 if (DIRECTORY_SEPARATOR !== '/') {
 $path = str_replace(DIRECTORY_SEPARATOR, '/', $path);
 }
 $path = '/' . ltrim($path, '/');
 return $path;
 }
 protected function _relpath($path) {
 return $path;
 }
 protected function _abspath($path) {
 return $path;
 }
 protected function _path($path) {
 return $this->rootName . $this->_normpath(substr($path, strlen($this->root)));
 }
 protected function _inpath($path, $parent) {
 return $path == $parent || strpos($path, $parent . '/') === 0;
 }
 protected function _stat($path) {
 if ($raw = $this->_bd_getRawItem($path)) {
 return $this->_bd_parseRaw($raw);
 }
 return false;
 }
 protected function _subdirs($path) {
 list(, $itemId) = $this->_bd_splitPath($path);
 $path = '/folders/' . $itemId . '/items?limit=1&offset=0&fields=' . self::FETCHFIELDS;
 $url = self::API_URL . $path;
 if ($res = $this->_bd_fetch($url)) {
 if ($res[0]->type == 'folder') {
 return true;
 }
 }
 return false;
 }
 protected function _dimensions($path, $mime) {
 if (strpos($mime, 'image') !== 0) {
 return '';
 }
 $ret = '';
 if ($work = $this->getWorkFile($path)) {
 if ($size = @getimagesize($work)) {
 $cache['width'] = $size[0];
 $cache['height'] = $size[1];
 $ret = array('dim' => $size[0] . 'x' . $size[1]);
 $srcfp = fopen($work, 'rb');
 if ($subImgLink = $this->getSubstituteImgLink(elFinder::$currentArgs['target'], $size, $srcfp)) {
 $ret['url'] = $subImgLink;
 }
 }
 }
 is_file($work) && @unlink($work);
 return $ret;
 }
 protected function _scandir($path) {
 return isset($this->dirsCache[$path]) ? $this->dirsCache[$path] : $this->cacheDir($path);
 }
 protected function _fopen($path, $mode = 'rb') {
 if ($mode === 'rb' || $mode === 'r') {
 list(, $itemId) = $this->_bd_splitPath($path);
 $data = array( 'target' => self::API_URL . '/files/' . $itemId . '/content', 'headers' => array('Authorization: Bearer ' . $this->token->data->access_token), );
 return elFinder::getStreamByUrl($data);
 }
 return false;
 }
 protected function _fclose($fp, $path = '') {
 fclose($fp);
 if ($path) {
 unlink($this->getTempFile($path));
 }
 }
 protected function _mkdir($path, $name) {
 try {
 list(, $parentId) = $this->_bd_splitPath($path);
 $params = array('name' => $name, 'parent' => array('id' => $parentId));
 $url = self::API_URL . '/folders';
 $curl = $this->_bd_prepareCurl(array( CURLOPT_URL => $url, CURLOPT_POST => true, CURLOPT_POSTFIELDS => json_encode($params), ));
 $folder = $this->_bd_curlExec($curl, $path);
 return $this->_joinPath($path, $folder->id);
 }
 catch (Exception $e) {
 return $this->setError('Box error: ' . $e->getMessage());
 }
 }
 protected function _mkfile($path, $name) {
 return $this->_save($this->tmpfile(), $path, $name, array());
 }
 protected function _symlink($target, $path, $name) {
 return false;
 }
 protected function _copy($source, $targetDir, $name) {
 try {
 list(, $parentId) = $this->_bd_splitPath($targetDir);
 list(, $srcId) = $this->_bd_splitPath($source);
 $srcItem = $this->_bd_getRawItem($source);
 $properties = array('name' => $name, 'parent' => array('id' => $parentId));
 $data = (object)$properties;
 $type = ($srcItem->type === 'folder') ? 'folders' : 'files';
 $url = self::API_URL . '/' . $type . '/' . $srcId . '/copy';
 $curl = $this->_bd_prepareCurl(array( CURLOPT_URL => $url, CURLOPT_POST => true, CURLOPT_POSTFIELDS => json_encode($data), ));
 $result = $this->_bd_curlExec($curl, $targetDir);
 if (isset($result->id)) {
 if ($type === 'folders' && isset($this->sessionCache['subdirs'])) {
 $this->sessionCache['subdirs'][$targetDir] = true;
 }
 return $this->_joinPath($targetDir, $result->id);
 }
 return false;
 }
 catch (Exception $e) {
 return $this->setError('Box error: ' . $e->getMessage());
 }
 }
 protected function _move($source, $targetDir, $name) {
 try {
 list(, $parentId) = $this->_bd_splitPath($targetDir);
 list(, $itemId) = $this->_bd_splitPath($source);
 $srcItem = $this->_bd_getRawItem($source);
 $properties = array('name' => $name, 'parent' => array('id' => $parentId));
 $type = ($srcItem->type === 'folder') ? 'folders' : 'files';
 $url = self::API_URL . '/' . $type . '/' . $itemId;
 $data = (object)$properties;
 $curl = $this->_bd_prepareCurl(array( CURLOPT_URL => $url, CURLOPT_CUSTOMREQUEST => 'PUT', CURLOPT_POSTFIELDS => json_encode($data), ));
 $result = $this->_bd_curlExec($curl, $targetDir, array( 'Content-Type: application/json', ));
 if ($result && isset($result->id)) {
 return $this->_joinPath($targetDir, $result->id);
 }
 return false;
 }
 catch (Exception $e) {
 return $this->setError('Box error: ' . $e->getMessage());
 }
 }
 protected function _unlink($path) {
 return $this->_bd_unlink($path, 'files');
 }
 protected function _rmdir($path) {
 return $this->_bd_unlink($path, 'folders');
 }
 protected function _save($fp, $path, $name, $stat) {
 $itemId = '';
 if ($name === '') {
 list($parentId, $itemId, $parent) = $this->_bd_splitPath($path);
 }
 else {
 if ($stat) {
 if (isset($stat['name'])) {
 $name = $stat['name'];
 }
 if (isset($stat['rev']) && strpos($stat['hash'], $this->id) === 0) {
 $itemId = $stat['rev'];
 }
 }
 list(, $parentId) = $this->_bd_splitPath($path);
 $parent = $path;
 }
 try {
 $metaDatas = stream_get_meta_data($fp);
 $tmpFilePath = isset($metaDatas['uri']) ? $metaDatas['uri'] : '';
 if (!$tmpFilePath || empty($metaDatas['seekable'])) {
 $tmpHandle = $this->tmpfile();
 stream_copy_to_stream($fp, $tmpHandle);
 $metaDatas = stream_get_meta_data($tmpHandle);
 $tmpFilePath = $metaDatas['uri'];
 }
 if ($itemId === '') {
 $properties = array('name' => $name, 'parent' => array('id' => $parentId));
 $url = self::UPLOAD_URL . '/files/content';
 }
 else {
 $properties = array('name' => $name);
 $url = self::UPLOAD_URL . '/files/' . $itemId . '/content';
 }
 if (class_exists('CURLFile')) {
 $cfile = new CURLFile($tmpFilePath);
 }
 else {
 $cfile = '@' . $tmpFilePath;
 }
 $params = array('attributes' => json_encode($properties), 'file' => $cfile);
 $curl = $this->_bd_prepareCurl(array( CURLOPT_URL => $url, CURLOPT_POST => true, CURLOPT_POSTFIELDS => $params, ));
 $file = $this->_bd_curlExec($curl, $parent);
 return $this->_joinPath($parent, $file->entries[0]->id);
 }
 catch (Exception $e) {
 return $this->setError('Box error: ' . $e->getMessage());
 }
 }
 protected function _getContents($path) {
 try {
 list(, $itemId) = $this->_bd_splitPath($path);
 $url = self::API_URL . '/files/' . $itemId . '/content';
 $contents = $this->_bd_fetch($url, true);
 }
 catch (Exception $e) {
 return $this->setError('Box error: ' . $e->getMessage());
 }
 return $contents;
 }
 protected function _filePutContents($path, $content) {
 $res = false;
 if ($local = $this->getTempFile($path)) {
 if (file_put_contents($local, $content, LOCK_EX) !== false && ($fp = fopen($local, 'rb'))) {
 clearstatcache();
 $res = $this->_save($fp, $path, '', array());
 fclose($fp);
 }
 file_exists($local) && unlink($local);
 }
 return $res;
 }
 protected function _checkArchivers() {
 return array();
 }
 protected function _chmod($path, $mode) {
 return false;
 }
 protected function _extract($path, $arc) {
 die('Not yet implemented. (_extract)');
 }
 protected function _archive($dir, $files, $name, $arc) {
 die('Not yet implemented. (_archive)');
 }
 }
 